<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class TabelPrecoModulesService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
	
	public function copiaPrecoDif($row) {
        $this->entityManager->getConnection()->beginTransaction();
        try{
        	$tipoProd = $row['TIPOPROD'];
        	$row['DTINIVGPREC'] = substr($row['DTINIVGPREC'],0,10);
        	
        	//busca o código dos produtos a serem alterados de acordo com a modalidade escolhida na tela
        	if ($tipoProd == 'T'){        		
        		$paramsT = array(
        			":CDPRODUTO" => $row['CDPRODUTO'],
        			":NRORG" => $row['NRORG'],
        			":CDFILIAL" => $row['CDFILIAL'],
			     	":CDTABEPREC" => $row['CDTABEPREC'],
			     	":DTINIVGPREC" => $row['DTINIVGPREC']
        		);
        		$produtos = $this->entityManager->getConnection()->fetchAll(self::SELECT_PROD_TODOS, $paramsT);
        	}
        	else if ($tipoProd == 'L'){
        		$produtoLista = $row['CDPRODUTOLISTA'];
        		$produtos = array();
        		foreach ($produtoLista as $produto){
        			$paramsList = array(
	        			":CDPRODUTOINI" => $produto,
	        			":CDPRODUTOFIN" => $produto,
	        			":NRORG" => $row['NRORG'],
	        			":CDFILIAL" => $row['CDFILIAL'],
				     	":CDTABEPREC" => $row['CDTABEPREC'],
				     	":DTINIVGPREC" => $row['DTINIVGPREC']
	        		);
        			array_push($produtos,$this->entityManager->getConnection()->fetchAll(self::SELECT_PROD_INTERVALO, $paramsList));
        		}
        		
        	}
        	else if ($tipoProd == 'I'){
        		$paramsInt = array(
        			":CDPRODUTOINI" => $row['CDPRODUTOINI'],
        			":CDPRODUTOFIN" => $row['CDPRODUTOFIN'],
        			":NRORG" => $row['NRORG'],
        			":CDFILIAL" => $row['CDFILIAL'],
			     	":CDTABEPREC" => $row['CDTABEPREC'],
			     	":DTINIVGPREC" => $row['DTINIVGPREC']
        		);
        		$produtos = $this->entityManager->getConnection()->fetchAll(self::SELECT_PROD_INTERVALO, $paramsInt);
        	}
        	
        	//seleciona os parametros do produto inicial que serão inseridos nos produtos selecionados
        	$paramsProd = array(
                	":CDFILIAL" => $row['CDFILIAL'],
			     	":CDTABEPREC" => $row['CDTABEPREC'],
			     	":CDPRODUTO" => $row['CDPRODUTO'],
			     	":DTINIVGPREC" => $row['DTINIVGPREC'],
			     	":NRORG" => $row['NRORG']
                );
                
        	$dias = $this->entityManager->getConnection()->fetchAll(self::SELECT_PRECDIF, $paramsProd);
        	
        	foreach($produtos as $produto){
        		
    			$paramsDel = array(
        			":CDPRODUTO" => isset($produto['CDPRODUTO']) ? $produto['CDPRODUTO'] : $produto[0]['CDPRODUTO'],
        			":CDTABEPREC" => $row['CDTABEPREC'],
        			":DTINIVGPREC" => $row['DTINIVGPREC'],
                	":CDFILIAL" => $row['CDFILIAL'],
			     	":NRORG" => $row['NRORG']
                );
	
        		$this->entityManager->getConnection()->executeQuery(self::DELETE_PRECODIA_PROD, $paramsDel);
				
        		foreach ($dias as $dia){
        			$dia['CDPRODUTO'] = isset($produto['CDPRODUTO']) ? $produto['CDPRODUTO'] : $produto[0]['CDPRODUTO'];
        			$dia['CDPRPAITABPR'] = isset($produto['CDPRPAITABPR']) ? $produto['CDPRPAITABPR'] : $produto[0]['CDPRPAITABPR'] ;
        			$dia['DTINIVGPREC'] = substr($dia['DTINIVGPREC'],0,10);
        			$dia['DTINIVALPREC'] = substr($dia['DTINIVALPREC'],0,10);
        			$dia['DTFINVALPREC'] = substr($dia['DTFINVALPREC'],0,10);
        			
        			$this->entityManager->getConnection()->executeQuery(self::INSERT_PRECODIA, $dia);
        		}
        	}
            $this->entityManager->getConnection()->commit();
        }catch(Exception $e){
        	throw $e;
        	$this->entityManager->getConnection()->rollBack();
        }
    }
    
    public function alt_autom($row){
    	$this->entityManager->getConnection()->beginTransaction();
    	
    	try{
    		$tipoProd = $row['TIPOPROD'];
        	$row['DTINIVGPREC'] = substr($row['DTINIVGPREC'],0,10);
        	
        	//busca o código dos produtos a serem alterados de acordo com a modalidade escolhida na tela
        	if ($tipoProd == 'T'){        		
        		$paramsT = array(
        			":NRORG" => $row['NRORG'],
        			":CDFILIAL" => $row['CDFILIAL'],
			     	":CDTABEPREC" => $row['CDTABEPREC'],
			     	":DTINIVGPREC" => $row['DTINIVGPREC']
        		);
        		$produtos = $this->entityManager->getConnection()->fetchAll(self::SELECT_PROD, $paramsT);
        	}
        	else if ($tipoProd == 'L'){
        		$produtoLista = $row['CDPRODUTOLISTA'];
        		$produtos = array();
        		foreach ($produtoLista as $produto){
        			$paramsList = array(
	        			":CDPRODUTOINI" => $produto,
	        			":CDPRODUTOFIN" => $produto,
	        			":NRORG" => $row['NRORG'],
	        			":CDFILIAL" => $row['CDFILIAL'],
				     	":CDTABEPREC" => $row['CDTABEPREC'],
				     	":DTINIVGPREC" => $row['DTINIVGPREC']
	        		);
        			array_push($produtos,$this->entityManager->getConnection()->fetchAll(self::SELECT_PROD_INTERVALO, $paramsList));
        		}
        		
        	}
        	else if ($tipoProd == 'I'){
        		$paramsInt = array(
        			":CDPRODUTOINI" => $row['CDPRODUTOINI'],
        			":CDPRODUTOFIN" => $row['CDPRODUTOFIN'],
        			":NRORG" => $row['NRORG'],
        			":CDFILIAL" => $row['CDFILIAL'],
			     	":CDTABEPREC" => $row['CDTABEPREC'],
			     	":DTINIVGPREC" => $row['DTINIVGPREC']
        		);
        		$produtos = $this->entityManager->getConnection()->fetchAll(self::SELECT_PROD_INTERVALO, $paramsInt);
        	}
			foreach($produtos as $produto){
	    		$paramsUpdate = array(
	                	":CDFILIAL" 	=> $row['CDFILIAL'],
				     	":CDTABEPREC"	=> $row['CDTABEPREC'],
				     	":CDPRODUTO"	=> isset($produto['CDPRODUTO']) ? $produto['CDPRODUTO'] : $produto[0]['CDPRODUTO'],
				     	":DTINIVGPREC"	=> $row['DTINIVGPREC'],
				     	":NRORG"		=> $row['NRORG'],
				     	":IDPRODPROMOC" => $row['IDPRODPROMOC']
	                );
	    		$this->entityManager->getConnection()->executeQuery(self::UPDATE_PROMO_PRODUTO, $paramsUpdate);
	    		
	    		$row['OPCPREFIX'] = isset($row['OPCPREFIX']) ? $row['OPCPREFIX'] : 'N';
	    		
	    		if ($row['OPCPREFIX'] == 'S'){
	    			$produto[0]['NMPRODUTO'] = isset($produto[0]['NMPRODUTO']) ? $produto[0]['NMPRODUTO'] : $produto['NMPRODUTO'];
	    			if ($row['TIPOPREFIXO'] == 'L'){
		    			$aux = substr($produto[0]['NMPRODUTO'], 0, strlen($row['PREFIX']));
		    			if ($aux = $row['PREFIX']) {
						    $produto[0]['NMPRODUTO'] = substr($produto[0]['NMPRODUTO'], strlen($row['PREFIX']));
						}
		    		} else {
		    			$produto[0]['NMPRODUTO'] = $row['PREFIX'] . $produto[0]['NMPRODUTO'];
		    		}
					$paramsName = array(
						":NRORG"	 => $row['NRORG'],
						":CDPRODUTO" => isset($produto['CDPRODUTO']) ? $produto['CDPRODUTO'] : $produto[0]['CDPRODUTO'],
						":NMPRODUTO" => $produto[0]['NMPRODUTO']
					);
					
					$this->entityManager->getConnection()->executeQuery(self::UPDATE_NOME_PRODUTO, $paramsName);
				}
			}

            $this->entityManager->getConnection()->commit();
    	}
    	catch(Exception $e){
        	throw $e;
        	$this->entityManager->getConnection()->rollBack();
        }
		
    }
    
    
    
    const UPDATE_PROMO_PRODUTO = "
	    UPDATE ITEMPRECO
			SET
			    IDPRODPROMOC = :IDPRODPROMOC
			WHERE
			        CDPRODUTO = :CDPRODUTO
			    AND CDFILIAL = :CDFILIAL
			    AND CDTABEPREC = :CDTABEPREC
			    AND DTINIVGPREC = :DTINIVGPREC
			    AND NRORG = :NRORG
    ";
    
    const UPDATE_NOME_PRODUTO = "
	    UPDATE PRODUTO
		    SET
		        NMPRODUTO = :NMPRODUTO
		    WHERE
		        	CDPRODUTO = :CDPRODUTO
		        AND NRORG = :NRORG
	";
    
    
    const SELECT_PRECDIF = "
	    SELECT
		    I.VRPRECODIADLV,
		    I.VRPRECODIACMD,
		    I.IDTPMODGERAL,
		    I.IDTPMODDLV,
		    I.IDTPMODCMD,
		    I.CDFILIAL,
		    I.IDATIVO,
		    I.NRORG,
		    I.VRPRECODIF,
		    I.CDTABEPREC,
		    I.DTINIVGPREC,
		    I.CDPRODUTO,
		    I.CDPRPAITABPR,
		    I.NRDIASEMANPR,
		    I.HRINIPRECDIA,
		    I.HRFINPRECDIA,
		    I.VRPRECODIA,
		    I.IDPERVALORPR,
		    I.IDDESCACREPR,
		    I.DTINIVALPREC,
		    I.DTFINVALPREC,
		    I.CDTIPOCONSPD,
		    I.IDVISUACUPOM
		FROM
		    ITEMPRECODIA I
		    LEFT JOIN TIPOCONS     T ON ( I.CDTIPOCONSPD = T.CDTIPOCONS )
		    LEFT JOIN TIPOCONSFILI TF ON ( ( TF.CDFILIAL = :CDFILIAL )
		                                   AND ( TF.CDTIPOCONS = I.CDTIPOCONSPD ) )
		    LEFT JOIN TABEVEND     TV ON ( I.CDTABEPREC = TV.CDTABEPREC
		                               AND I.CDFILIAL = TV.CDFILIAL
		                               AND I.DTINIVGPREC = TV.DTINIVGPREC )
		WHERE 
		    I.CDPRODUTO = :CDPRODUTO AND
		    I.CDTABEPREC = :CDTABEPREC AND
		    I.DTINIVGPREC = :DTINIVGPREC AND
		    I.CDFILIAL = :CDFILIAL AND
		    I.NRORG = :NRORG
		ORDER BY
		    I.NRDIASEMANPR,
		    I.HRINIPRECDIA,
	    I.HRFINPRECDIA
    ";
    
    const SELECT_PROD_INTERVALO = "
	    SELECT
		    PR.CDPRODUTO,
		    NVL(IP.CDPRPAITABPR, PR.CDPRODUTO) AS CDPRPAITABPR,
		    PR.NMPRODUTO
		FROM
		    PRODUTO   PR,
		    ITEMPRECO IP,
		    (
		        SELECT
		            COUNT(*) AS NRCOMPPROD,
		            CDPRODUTO,
		            NRORG
		        FROM
		            ROTFABRICA
		        WHERE
		            NRORG = :NRORG
		        GROUP BY
		            CDPRODUTO,
		            NRORG
		    )         R
		WHERE
		    PR.NRORG = :NRORG
		    AND ( IP.CDPRODUTO BETWEEN :CDPRODUTOINI AND :CDPRODUTOFIN )
		    AND ( PR.CDPRODUTO = IP.CDPRODUTO )
		    AND ( PR.NRORG = IP.NRORG )
		    AND ( PR.CDPRODUTO = NVL(IP.CDPRPAITABPR, PR.CDPRODUTO) )
		    AND ( IP.CDPRPAITABPR = PR.CDPRODUTO )
		    AND ( IP.CDFILIAL = :CDFILIAL )
		    AND ( IP.CDTABEPREC = :CDTABEPREC )
		    AND ( IP.DTINIVGPREC = :DTINIVGPREC )
		    AND ( R.CDPRODUTO (+) = PR.CDPRODUTO )
		    AND ( R.NRORG (+) = PR.NRORG )
		    AND ( NVL(PR.IDPRODATIVPR, 'S') = 'S' )
		ORDER BY
		    PR.CDPRODUTO
    ";
    
    
    const SELECT_PROD = "
	    SELECT
		    PR.CDPRODUTO,
		    NVL(IP.CDPRPAITABPR, PR.CDPRODUTO) AS CDPRPAITABPR,
		    PR.NMPRODUTO
		FROM
		    PRODUTO   PR,
		    ITEMPRECO IP,
		    (
		        SELECT
		            COUNT(*) AS NRCOMPPROD,
		            CDPRODUTO,
		            NRORG
		        FROM
		            ROTFABRICA
		        WHERE
		            NRORG = :NRORG
		        GROUP BY
		            CDPRODUTO,
		            NRORG
		    )         R
		WHERE
		    PR.NRORG = :NRORG
		    AND ( PR.CDPRODUTO = IP.CDPRODUTO )
		    AND ( PR.NRORG = IP.NRORG )
		    AND ( PR.CDPRODUTO = NVL(IP.CDPRPAITABPR, PR.CDPRODUTO) )
		    AND ( IP.CDPRPAITABPR = PR.CDPRODUTO )
		    AND ( IP.CDFILIAL = :CDFILIAL )
		    AND ( IP.CDTABEPREC = :CDTABEPREC )
		    AND ( IP.DTINIVGPREC = :DTINIVGPREC )
		    AND ( R.CDPRODUTO (+) = PR.CDPRODUTO )
		    AND ( R.NRORG (+) = PR.NRORG )
		    AND ( NVL(PR.IDPRODATIVPR, 'S') = 'S' )
		ORDER BY
		    PR.CDPRODUTO
    ";
    
    
    const SELECT_PROD_TODOS = "
	    SELECT
		    PR.CDPRODUTO,
		    NVL(IP.CDPRPAITABPR, PR.CDPRODUTO) AS CDPRPAITABPR,
		    PR.NMPRODUTO
		FROM
		    PRODUTO   PR,
		    ITEMPRECO IP,
		    (
		        SELECT
		            COUNT(*) AS NRCOMPPROD,
		            CDPRODUTO,
		            NRORG
		        FROM
		            ROTFABRICA
		        WHERE
		            NRORG = :NRORG
		        GROUP BY
		            CDPRODUTO,
		            NRORG
		    )         R
		WHERE
		    PR.NRORG = :NRORG
		    AND (IP.CDPRODUTO <> :CDPRODUTO)
		    AND ( PR.CDPRODUTO = IP.CDPRODUTO )
		    AND ( PR.NRORG = IP.NRORG )
		    AND ( PR.CDPRODUTO = NVL(IP.CDPRPAITABPR, PR.CDPRODUTO) )
		    AND ( IP.CDPRPAITABPR = PR.CDPRODUTO )
		    AND ( IP.CDFILIAL = :CDFILIAL )
		    AND ( IP.CDTABEPREC = :CDTABEPREC )
		    AND ( IP.DTINIVGPREC = :DTINIVGPREC )
		    AND ( R.CDPRODUTO (+) = PR.CDPRODUTO )
		    AND ( R.NRORG (+) = PR.NRORG )
		    AND ( NVL(PR.IDPRODATIVPR, 'S') = 'S' )
		ORDER BY
		    PR.CDPRODUTO
    ";
	
	const DELETE_PRECODIA_PROD = "
	    DELETE FROM ITEMPRECODIA
            WHERE CDPRODUTO = :CDPRODUTO
                AND CDTABEPREC = :CDTABEPREC
                AND DTINIVGPREC = :DTINIVGPREC
                AND CDFILIAL = :CDFILIAL
                AND NRORG = :NRORG
	";
	
	const INSERT_PRECODIA = "
		INSERT INTO ITEMPRECODIA (
		    VRPRECODIADLV,
		    VRPRECODIACMD,
		    IDTPMODGERAL,
		    IDTPMODDLV,
		    IDTPMODCMD,
		    CDFILIAL,
		    IDATIVO,
		    NRORG,
		    VRPRECODIF,
		    CDTABEPREC,
		    DTINIVGPREC,
		    CDPRODUTO,
		    CDPRPAITABPR,
		    NRDIASEMANPR,
		    HRINIPRECDIA,
		    HRFINPRECDIA,
		    VRPRECODIA,
		    IDPERVALORPR,
		    IDDESCACREPR,
		    DTINIVALPREC,
		    DTFINVALPREC,
		    CDTIPOCONSPD,
		    IDVISUACUPOM
		) VALUES (
		    :VRPRECODIADLV,
		    :VRPRECODIACMD,
		    :IDTPMODGERAL,
		    :IDTPMODDLV,
		    :IDTPMODCMD,
		    :CDFILIAL,
		    :IDATIVO,
		    :NRORG,
		    :VRPRECODIF,
		    :CDTABEPREC,
		    :DTINIVGPREC,
		    :CDPRODUTO,
		    :CDPRPAITABPR,
		    :NRDIASEMANPR,
		    :HRINIPRECDIA,
		    :HRFINPRECDIA,
		    :VRPRECODIA,
		    :IDPERVALORPR,
		    :IDDESCACREPR,
		    :DTINIVALPREC,
		    :DTFINVALPREC,
		    :CDTIPOCONSPD,
		    :IDVISUACUPOM
		)
	";
}